Skip to content

Topology ​

20 operations. Call any of them with omada_call_operation (or, in full tool mode, as a tool named by its operationId).

OperationMethodSummary
getDeviceLinkTopologyGETGet Device Link Topology
getTopologyGETGet site topology
refreshTopologyPOSTRefresh site topology
getDevicesOfVlanGETSearch Devices of Vlan in Topology
getAvailableNetworksGETGet available network
getGridAvailableSsidsGETGet available ssids
getAvailableVlansGETGet available vlans
getTopologyClientsByDeviceGETGet the clients by device
getTopologyClientsGETGet the clients
getTopologyClientsByDevicesPOSTGet the clients by devices.
getTopologyDiscoveryStatusGETGet topology discovery status
getIsolatedAndPreConfigDevicesGETGet isolated and preconfigured devices
getTopologyNodesGETGet topology nodes
setTopologyNodePOSTSet site topology top node
getGridDeviceClientGETSearch Device or Client in Topology
getDevicesOfSsidGETSearch Devices of Ssid in Topology
getMspDeviceLinkTopologyGETGet Msp Device Link Topology
getV3TopologyGETGet site topology, version 3
getFilterDevicesOfVlanGETFilter Devices of Vlan in Topology
getFilterDevicesOfSsidGETFilter Devices of Ssid in Topology

getDeviceLinkTopology ​

GET /openapi/v2/{omadacId}/sites/{siteId}/devices/{deviceMac}/device-link-topology

Get Device Link Topology

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
deviceMacpathstringyesDevice MAC address, like AA-BB-CC-DD-EE-FF
json
// omada_call_operation
{
  "operationId": "getDeviceLinkTopology",
  "params": {
    "siteId": "<siteId>",
    "deviceMac": "<deviceMac>"
  }
}
Details, permissions and error codes

Get link topology of the device with the given omadacId, siteId and deviceMac.
The interface requires one of the permissions:
Site Settings Manager View Only
Site Device Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getTopology ​

GET /openapi/v2/{omadacId}/sites/{siteId}/topology

Get site topology

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
json
// omada_call_operation
{
  "operationId": "getTopology",
  "params": {
    "siteId": "<siteId>"
  }
}
Details, permissions and error codes

Get topology of the site with the given omadacId and siteId.
The interface requires one of the permissions:
Site Map Manager View Only
Site Home View Only
Site Dashboard Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

refreshTopology ​

POST /openapi/v2/{omadacId}/sites/{siteId}/topology

Refresh site topology

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
json
// omada_call_operation
{
  "operationId": "refreshTopology",
  "params": {
    "siteId": "<siteId>"
  }
}
Details, permissions and error codes

Refresh topology of the site with the given omadacId and siteId.
The interface requires one of the permissions:
Site Map Manager View Only
Site Home View Only
Site Dashboard Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getDevicesOfVlan ​

GET /openapi/v2/{omadacId}/sites/{siteId}/topology/{networkId}/vlan/{vlan}/devices

Search Devices of Vlan in Topology

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
networkIdpathstringyesnetworkId
vlanpathstringyesvlan
json
// omada_call_operation
{
  "operationId": "getDevicesOfVlan",
  "params": {
    "siteId": "<siteId>",
    "networkId": "<networkId>",
    "vlan": "<vlan>"
  }
}
Details, permissions and error codes

Search for devices of vlan in topology with given omadacId and siteId by networkId and vlan.
The interface requires one of the permissions:
Site Settings Manager View Only
Site Device Manager View Only
Site Dashboard Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getAvailableNetworks ​

GET /openapi/v2/{omadacId}/sites/{siteId}/topology/available-network

Get available network

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
json
// omada_call_operation
{
  "operationId": "getAvailableNetworks",
  "params": {
    "siteId": "<siteId>"
  }
}
Details, permissions and error codes

Get available wired and wireless network with the given omadacId and siteId.
The interface requires one of the permissions:
Site Map Manager View Only
Site Dashboard Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getGridAvailableSsids ​

GET /openapi/v2/{omadacId}/sites/{siteId}/topology/available-ssids

Get available ssids

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
pagequeryintegernoStart page number. Start from 1. (default 1)
pageSizequeryintegernoNumber of entries per page. It should be within the range of 1–1000. (default 100)
searchKeyquerystringyesFuzzy query parameters, support field
json
// omada_call_operation
{
  "operationId": "getGridAvailableSsids",
  "params": {
    "siteId": "<siteId>",
    "searchKey": "<searchKey>"
  }
}
Details, permissions and error codes

Get available wireless network with the given omadacId and siteId.
The interface requires one of the permissions:
Site Map Manager View Only
Site Dashboard Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getAvailableVlans ​

GET /openapi/v2/{omadacId}/sites/{siteId}/topology/available-vlans

Get available vlans

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
json
// omada_call_operation
{
  "operationId": "getAvailableVlans",
  "params": {
    "siteId": "<siteId>"
  }
}
Details, permissions and error codes

Get available wired network with the given omadacId and siteId.
The interface requires one of the permissions:
Site Map Manager View Only
Site Dashboard Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getTopologyClientsByDevice ​

GET /openapi/v2/{omadacId}/sites/{siteId}/topology/devices/{mac}/all-clients

Get the clients by device

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
macpathstringyesDevice MAC address, like AA-BB-CC-DD-EE-FF
filters.typequerystringyesFilter query parameters, support field filter client group type. 0: except ipc; 1: just ipc; 0,1: all client.
json
// omada_call_operation
{
  "operationId": "getTopologyClientsByDevice",
  "params": {
    "siteId": "<siteId>",
    "mac": "<mac>",
    "filters.type": "<filters.type>"
  }
}
Details, permissions and error codes

Get the clients in topology of the device with the given omadacId , siteId and device Mac.
The interface requires one of the permissions:
Site Map Manager View Only
Site Dashboard Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getTopologyClients ​

GET /openapi/v2/{omadacId}/sites/{siteId}/topology/devices/{mac}/clients

Get the clients

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
macpathstringyesDevice MAC address, like AA-BB-CC-DD-EE-FF
json
// omada_call_operation
{
  "operationId": "getTopologyClients",
  "params": {
    "siteId": "<siteId>",
    "mac": "<mac>"
  }
}
Details, permissions and error codes

Get the clients in topology of the device with the given omadacId , siteId and device Mac.
The interface requires one of the permissions:
Site Map Manager View Only
Site Home View Only
Site Dashboard Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getTopologyClientsByDevices ​

POST /openapi/v2/{omadacId}/sites/{siteId}/topology/devices/all-clients

Get the clients by devices.

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)

Request body — application/json (required) — schema TopologyClientsQuery

FieldTypeRequiredDescription
deviceMacsarray<ClientsQueryMacAndFilterType>noDevice macs.
json
// omada_call_operation
{
  "operationId": "getTopologyClientsByDevices",
  "params": {
    "siteId": "<siteId>"
  },
  "body": "{...}"
}
Details, permissions and error codes

Get the clients in topology of the devices with the given omadacId , siteId and device macs.
The interface requires one of the permissions:
Site Settings Manager Modify
Site Dashboard Manager Modify
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getTopologyDiscoveryStatus ​

GET /openapi/v2/{omadacId}/sites/{siteId}/topology/discovery/status

Get topology discovery status

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
json
// omada_call_operation
{
  "operationId": "getTopologyDiscoveryStatus",
  "params": {
    "siteId": "<siteId>"
  }
}
Details, permissions and error codes

Get the status of whether the topology is calculating or not with the given omadacId and siteId.
The interface requires one of the permissions:
Site Map Manager View Only
Site Home View Only
Site Dashboard Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getIsolatedAndPreConfigDevices ​

GET /openapi/v2/{omadacId}/sites/{siteId}/topology/isolated-and-pre-config

Get isolated and preconfigured devices

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
json
// omada_call_operation
{
  "operationId": "getIsolatedAndPreConfigDevices",
  "params": {
    "siteId": "<siteId>"
  }
}
Details, permissions and error codes

Get devices whose status is isolated or pre config with the given omadacId and siteId.
The interface requires one of the permissions:
Site Map Manager View Only
Site Dashboard Manager View Only
Network Config Page View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getTopologyNodes ​

GET /openapi/v2/{omadacId}/sites/{siteId}/topology/nodes

Get topology nodes

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
json
// omada_call_operation
{
  "operationId": "getTopologyNodes",
  "params": {
    "siteId": "<siteId>"
  }
}
Details, permissions and error codes

Get the nodes in topology that can be set as topNode with the given omadacId and siteId. Only three types could be set when there is no gateway:switch、olt and other. Otherwise, this method will return empty list
The interface requires one of the permissions:
Site Map Manager View Only
Site Home View Only
Site Dashboard Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

setTopologyNode ​

POST /openapi/v2/{omadacId}/sites/{siteId}/topology/nodes

Set site topology top node

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)

Request body — application/json (required) — schema TopologyRootNode

FieldTypeRequiredDescription
typestringnoRoot Node Type, which can only be one of the following three types: switch, olt and other.
macstringnoRoot Node MAC address, like AA-BB-CC-DD-EE-FF.
specificTypeintegernoMultiSwitch Node SpecificType, which can only be one of the following two types: 0:Mlag and 1:Vrrp.
macListarray<string>noMultiSwitch Node MAC list.
discoveryModeintegernoDiscovery Mode, which can only be one of the following two types: 0:Manual and 1:Auto.
json
// omada_call_operation
{
  "operationId": "setTopologyNode",
  "params": {
    "siteId": "<siteId>"
  },
  "body": "{...}"
}
Details, permissions and error codes

Set topology top node of the site with the given omadacId, siteId and rootNode. Only three types could be set when there is no gateway:switch、olt and other. Otherwise, this method is invalid
The interface requires one of the permissions:
Site Map Manager Modify
Site Home Modify
Site Dashboard Manager Modify
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getGridDeviceClient ​

GET /openapi/v2/{omadacId}/sites/{siteId}/topology/search-device-client

Search Device or Client in Topology

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
pagequeryintegernoStart page number. Start from 1. (default 1)
pageSizequeryintegernoNumber of entries per page. It should be within the range of 1–1000. (default 100)
searchKeyquerystringyesFuzzy query parameters, support field
json
// omada_call_operation
{
  "operationId": "getGridDeviceClient",
  "params": {
    "siteId": "<siteId>",
    "searchKey": "<searchKey>"
  }
}
Details, permissions and error codes

Search for devices or clients in topology with given omadacId and siteId by mac and name.
The interface requires one of the permissions:
Site Map Manager View Only
Site Dashboard Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getDevicesOfSsid ​

GET /openapi/v2/{omadacId}/sites/{siteId}/topology/ssids/{ssidId}/devices

Search Devices of Ssid in Topology

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
ssidIdpathstringyesSSID ID
json
// omada_call_operation
{
  "operationId": "getDevicesOfSsid",
  "params": {
    "siteId": "<siteId>",
    "ssidId": "<ssidId>"
  }
}
Details, permissions and error codes

Search for devices of ssid in topology with given omadacId and siteId by ssidId.
The interface requires one of the permissions:
Site Settings Manager View Only
Site Dashboard Manager View Only
Site Device Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getMspDeviceLinkTopology ​

GET /openapi/v2/msp/{mspId}/customers/{customerId}/sites/{siteId}/devices/{deviceMac}/device-link-topology

Get Msp Device Link Topology

ParameterInTypeRequiredDescription
mspIdpathstringautoMSP ID (filled in automatically)
customerIdpathstringyesCustomer ID
siteIdpathstringyesSite ID (site ID or site name)
deviceMacpathstringyesDevice MAC address, like AA-BB-CC-DD-EE-FF
json
// omada_call_operation
{
  "operationId": "getMspDeviceLinkTopology",
  "params": {
    "customerId": "<customerId>",
    "siteId": "<siteId>",
    "deviceMac": "<deviceMac>"
  }
}
Details, permissions and error codes

Get msp link topology of the device with the given mspId, siteId and deviceMac.
The interface requires one of the permissions:
Site Settings Manager View Only
MSP Device Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getV3Topology ​

GET /openapi/v3/{omadacId}/sites/{siteId}/topology

Get site topology, version 3

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
filters.deviceStatusquerystringyesFilter query parameters, support field device status. 0: connected; 1: disconnected; 0,1: both.
json
// omada_call_operation
{
  "operationId": "getV3Topology",
  "params": {
    "siteId": "<siteId>",
    "filters.deviceStatus": "<filters.deviceStatus>"
  }
}
Details, permissions and error codes

Get topology of the site with the given omadacId, siteId and deviceStatus.
The interface requires one of the permissions:
Site Map Manager View Only
Site Home View Only
Site Dashboard Manager View Only
Network Config Page View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getFilterDevicesOfVlan ​

GET /openapi/v3/{omadacId}/sites/{siteId}/topology/{networkId}/vlan/{vlan}/devices

Filter Devices of Vlan in Topology

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
networkIdpathstringyesnetworkId
vlanpathstringyesvlan
json
// omada_call_operation
{
  "operationId": "getFilterDevicesOfVlan",
  "params": {
    "siteId": "<siteId>",
    "networkId": "<networkId>",
    "vlan": "<vlan>"
  }
}
Details, permissions and error codes

Filter devices of vlan in topology with given omadacId and siteId by networkId and vlan.
The interface requires one of the permissions:
Site Settings Manager View Only
Site Device Manager View Only
Site Dashboard Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

getFilterDevicesOfSsid ​

GET /openapi/v3/{omadacId}/sites/{siteId}/topology/ssids/{ssidId}/devices

Filter Devices of Ssid in Topology

ParameterInTypeRequiredDescription
omadacIdpathstringautoOmada ID (filled in automatically)
siteIdpathstringyesSite ID (site ID or site name)
ssidIdpathstringyesSSID ID
json
// omada_call_operation
{
  "operationId": "getFilterDevicesOfSsid",
  "params": {
    "siteId": "<siteId>",
    "ssidId": "<ssidId>"
  }
}
Details, permissions and error codes

Filter devices of ssid in topology with given omadacId and siteId by ssidId.
The interface requires one of the permissions:
Site Settings Manager View Only
Site Dashboard Manager View Only
Site Device Manager View Only
The possible error code for the interface in the returned body is one of the following error codes (non generic error codes):
-33004 - Operation failed because other operations (site copying, restoring, template synchronizing, etc.) are being performed on this site. Please wait and try again later.

Released under the MIT License. Not affiliated with or endorsed by TP-Link.